/*
 * ChatGui.java
 *
 * Created on March 10, 2009, 12:56 PM
 */
package chatserver;

import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.sql.*;

/**
 *
 * @author  isaaclw
 */
public class ChatGui extends javax.swing.JFrame {

    private static Server aServer;
    private static Thread serverThread;

    /** Creates new form ChatGui */
    public ChatGui() {
        initComponents();
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new ChatGui().setVisible(true);
                txtChat.setText("Gui Created, ready to start");
                aServer = new Server(); // have to wait to start the server till we're accepting incoming.
                serverThread = new Thread(aServer);
                serverThread.start();
            }
        });
    }

    /** This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        dialogPane = new javax.swing.JScrollPane();
        txtChat = new javax.swing.JTextArea();
        txtCommand = new javax.swing.JTextField();
        butSend = new javax.swing.JButton();
        butDisc = new javax.swing.JButton();
        listPane = new javax.swing.JScrollPane();
        clientList = new javax.swing.JList();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        txtChat.setColumns(20);
        txtChat.setRows(5);
        txtChat.setCaretPosition(txtChat.getSelectionEnd());
        dialogPane.setViewportView(txtChat);

        txtCommand.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txtCommandActionPerformed(evt);
            }
        });

        butSend.setText("Send to Client");
        butSend.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                butSendActionPerformed(evt);
            }
        });

        butDisc.setText("Disconnect");
        butDisc.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                butDiscActionPerformed(evt);
            }
        });

        listPane.setViewportView(clientList);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(butDisc, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(listPane, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 111, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(txtCommand, javax.swing.GroupLayout.DEFAULT_SIZE, 321, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(butSend))
                    .addComponent(dialogPane, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 429, Short.MAX_VALUE)))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(dialogPane, javax.swing.GroupLayout.DEFAULT_SIZE, 276, Short.MAX_VALUE)
                    .addComponent(listPane, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 276, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(butSend)
                    .addComponent(butDisc)
                    .addComponent(txtCommand, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

private void butSendActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_butSendActionPerformed
    prvMessage();
}//GEN-LAST:event_butSendActionPerformed

private void butDiscActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_butDiscActionPerformed
    Object items[] = clientList.getSelectedValues();
    for (int i = 0; i < items.length; i++) {
        try {
            aServer.disconnect(items[i].toString());
        } catch (IOException ex) {
            Logger.getLogger(ChatGui.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
}//GEN-LAST:event_butDiscActionPerformed

private void txtCommandActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txtCommandActionPerformed
    prvMessage();
}//GEN-LAST:event_txtCommandActionPerformed
    
    private void prvMessage() {
        Object names[] = clientList.getSelectedValues();
        for (int i = 0; i < names.length; i++) {
            try {
                aServer.message(names[i].toString(), txtCommand.getText());
            } catch (IOException ex) {
                Logger.getLogger(ChatGui.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }

    static void MessageOut(String s) {
        Time t = new Time(System.currentTimeMillis());
        txtChat.append("\n("+t.toString()+") "+s);
        txtChat.setCaretPosition(txtChat.getText().length());
    }
    
    static void updateList() {
        clientList.setListData(aServer.clients());
    }
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private static javax.swing.JButton butDisc;
    private static javax.swing.JButton butSend;
    private static javax.swing.JList clientList;
    private javax.swing.JScrollPane dialogPane;
    private javax.swing.JScrollPane listPane;
    private static javax.swing.JTextArea txtChat;
    private static javax.swing.JTextField txtCommand;
    // End of variables declaration//GEN-END:variables
    
}
